Package: AnVILPublish
Title: Publish Packages and Other Resources to AnVIL Workspaces
Version: 1.21.0
Authors@R: c(
    person(
        "Marcel", "Ramos", role = c("aut", "cre"),
        email = "marcel.ramos@sph.cuny.edu",
        comment = c(ORCID = "0000-0002-3242-0582")
    ),
    person(
        "Martin", "Morgan", role = c("aut"),
        comment = c(ORCID = "0000-0002-5874-8148")
    ),
    person("Kayla", "Interdonato", role = "aut"),
    person(
        "Vincent", "Carey", role = "ctb",
        comment = c(ORCID = "0000-0003-4046-0063")
    ))
Description: 
    Use this package to create or update AnVIL workspaces from
    resources such as R / Bioconductor packages. The metadata about
    the package (e.g., select information from the package DESCRIPTION
    file and from vignette YAML headings) are used to populate the
    'DASHBOARD'. Vignettes are translated to python notebooks ready
    for evaluation in AnVIL.
License: Artistic-2.0
Imports: AnVIL, AnVILGCP, BiocBaseUtils, BiocManager, httr, jsonlite,
        rmarkdown, yaml, readr, whisker, tools, utils, stats
Suggests: knitr, BiocStyle, GCPtools, testthat (>= 3.0.0)
biocViews: Infrastructure, Software
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
VignetteBuilder: knitr
Config/testthat/edition: 3
Date: 2025-08-12
git_url: https://git.bioconductor.org/packages/AnVILPublish
git_branch: devel
git_last_commit: aafcf59
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 20:02:56 UTC; biocbuild
Author: Marcel Ramos [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3242-0582>),
  Martin Morgan [aut] (ORCID: <https://orcid.org/0000-0002-5874-8148>),
  Kayla Interdonato [aut],
  Vincent Carey [ctb] (ORCID: <https://orcid.org/0000-0003-4046-0063>)
Maintainer: Marcel Ramos <marcel.ramos@sph.cuny.edu>

# AnVILPublish

This package produces AnVIL workspaces from R packages. Use this package
to create or update AnVIL workspaces from resources such as R /
Bioconductor packages. The metadata about the package (e.g., select
information from the package `DESCRIPTION` file and from vignette `YAML`
headings) are used to populate the ‘DASHBOARD’ page on AnVIL. Vignettes
are translated to python notebooks ready for evaluation in AnVIL.

## Package installation

If necessary, install the AnVILPublish library

``` r
if (!"AnVILPublish" %in% rownames(installed.packages()))
    BiocManager::install("AnVILPublish")
```

# Requirements

**Note**. The package currently works for Google Cloud Platform
workspaces and does *NOT* support AnVIL workspaces that use the Azure
platform.

## Best practices

There are only a small number of functions in the package; it is likely
best practice to invoke these using `AnVILPublish::...()` rather than
attaching the package to the search path.

## The `gcloud` SDK

It is necessary to have the [gcloud SDK](https://cloud.google.com/sdk)
available to copy notebook files to the workspace. Test availability
with

``` r
GCPtools::gcloud_exists()
```

and verify that the account and project are appropriate (consistent with
AnVIL credentials) for use with AnVIL

``` r
GCPtools::gcloud_account()
GCPtools::gcloud_project()
```

Note that these be used to set, as well as interrogate, the account and
project.

## `Quarto` software

Conversion of Rmarkdown (`.Rmd`) or Quarto (`.Qmd`) vignettes to Jupyter
(`.ipynb`) notebooks uses [Quarto](https://quarto.org) software. It must
be available from within *R*, e.g.,

``` r
system2("quarto", "--version")
```

The user must determine if they want their vignettes converted or
rendered into Jupyter notebooks. The difference is that `render`
automatically executes *R* code blocks and embeds images, while
`convert` will not.

Use of Python *notedown* for conversion is no longer supported.

# Creating or updating workspaces

**CAUTION** updating an existing workspace will replace existing content
in a way that cannot be undone – you will lose content!

Workspace creation or update uses information from the DESCRIPTION file,
CSV files in inst/tables, and from the YAML metadata at the top of
vignettes. It is therefore worth-while to make sure this information is
accurate.

In the DESCRIPTION file, the Title, Version, Date, <Authors@R>
(preferred) or Author / Maintainer fields, Description, and License
fields are used.

Tables in inst/tables must be CSV files. Individual entries in the CSV
file may contain ‘whisker’ expressions for variable substitution, as
follows:

- `{{ bucket }}`: the bucket location of the (possibly newly created)
  workspace, as returned by `avstorage()`.

Tables are processed first with `whisker.render()` for variable
substitution, and then `readr::read_csv()` and `avtable_import()`.

In vignettes, the `title:`, `author:`, and `name:` fields are used. The
abstract is a good candidate for future inclusion.

## From package source

The one-stop route is to create a workspace from the local package
source (e.g., GitHub checkout) directory using `as_workspace()`.

``` r
AnVILPublish::as_workspace(
    "path/to/package",
    "bioconductor-rpci-anvil",     # i.e., billing account
    create = TRUE                  # use update = TRUE for an existing workspace
)
```

Use `create = TRUE` to create a new workspace. Use `update = TRUE` to
update (and potentially overwrite) an existing workspace. One of
`create` and `update` must be TRUE. The command illustrated above does
not specify the `name =` argument, so creates or updates a workspace
`"Bioconductor-Package-<pkgname>`, where `<pkgname>` is the name of the
package read from the DESCRIPTION file; provide an explicit name to
create or update an arbitrary workspace. The option `use_readme = TRUE`
appends a `README.md` file to the formatted content of the `DESCRIPTION`
file.

`AnVILPublish::as_workspace()` invokes `as_notebook()` so this step does
not need to be performed ‘by hand’.

See the command `add_access()`, below, to make the workspace available
to a wider audience.

## From collections of Rmd files

Some *R* resources, e.g., [bookdown](https://bookdown.org/) sites, are
not in packages. These can be processed to workspaces with minor
modifications.

1.  Add a standard DESCRIPTION file (e.g.,
    `use_this::use_description()`) to the directory containing the
    `.Rmd` files.

2.  Use the `Package:` field to provide a one-word identifier (e.g.,
    `Package: Bioc2020CNV`) for your material. Add a key-value pair
    `Type: Workshop` or similar. The `Pacakge:` and `Type:` fields will
    be used to create the workspace name as, in the example here,
    `Bioconductor-Workshop-Bioc2020CNV`.

3.  Add a ‘yaml’ chunk to the top of each `.Rmd` file, if not already
    present, including the title and (optionally) name information,
    e.g.,

        ---
        title: "01. Introduction to the workshop"
        author:
        - name: Iman Author
        - name: Imanother Author
        ---

Publish the resources with

``` r
AnVILPublish::as_workspace(
    "path/to/directory",      # directory containing DESCRIPTION file
    "bioconductor-rpci-anvil",
    create = TRUE
)
```

# Updating notebooks or workspace permissions

These steps are performed automatically by `as_workspace()`, but may be
useful when developing a new workspace or revising existing workspaces.

## Updating workspace notebooks from vignettes

Transforming vignettes to notebooks may require several iterations, and
is available as a separate operation. Use `update = FALSE` to create
local copies for preview.

``` r
AnVILPublish::as_notebook(
    "paths/to/files.Rmd",
    "bioconductor-rpci-anvil",     # i.e., billing account
    "Bioconductor-Package-Foo",    # Workspace name
    update = FALSE                 # make notebooks, but do not update workspace
)
```

The vignette transformation process has several limitations. Only `.Rmd`
vignettes are supported. Currently, the vignette is transformed first to
a markdown document using the `rmarkdown` command
`render(..., md_document())`. The markdown document is then translated
to Python notebook using `quarto`.

It is likely that some of the limitations of vignette rendering can be
reduced.

## Adding user access credentials to share the notebook

The `"Bioconductor_User"` group can be added to the entities that can
see the workspace. AnVIL users wishing to view the workspace should be
added to the `Bioconductor_User` group, rather than to the workspace
directly. To add the user group, use

``` r
AnVILPublish::add_access(
    "bioconductor-rpci-anvil",
    "Bioconductor-Package-Foo"
)
```

# Vignette and .Rmd best practices

## Orientation

`.Rmd` files need to be converted to jupyter notebooks. These ‘best
practices’ lead to results that are more likely to be satisfactory, as
outlined here.

## Best practices

1.  For packages, make sure the DESCRIPTION file is complete. Use the
    `Authors@R` notation for fully specifying authors. Add a `Date:`
    field indicating date of last modification. Follow other
    Bioconductor best practices, e.g., using and incrementing
    appropriate version numbers.

2.  For collections of vignettes not in a package (e.g., a bookdown
    folder), add a DESCRIPTION file at the top level. An example is

        Package: BCC2020
        Type: Workshop
        Title: R / Bioconductor in the AnVIL Cloud
        Version: 1.0.0
        Authors@R: 
            c(person(
                given = "Martin",
                family = "Morgan",
                role = c("aut", "cre"),
                email = "Martin.Morgan@RoswellPark.org",
                comment = c(ORCID = "0000-0002-5874-8148")
            ),
            person("Nitesh", "Turaga", role = "ctb"),
            person("Lori", "Shepherd", role = "ctb"))
        Description:
            This book contains material for a 2 1/2 hour course offered at the
            Bioinformatics Community Conference 2020. Bioconductor provides
            more than 1900 R packages for the analysis and comprehension of
            high-throughput genomic data. Most users install and run
            Bioconductor on a personal computer or perhaps use an academic
            cluster. Cloud-based solutions are increasing appealing, removing
            the headaches of local installation while providing access to (a)
            better, scalable computing resources; and (b) large-scale
            'consortium' and other reference data sets. This session
            introduces the AnVIL cloud computing environment. We cover use of
            the cloud as a replacement to desktop-style computing; integrating
            workflows for 'upstream' processing of large data resources with
            interactive 'downstream' analysis and comprehension, using Human
            Cell Atlas single-cell datasets as an example; and querying
            cloud-based consortium data for integration with a users own data
            sets.
        License: CC-BY
        Date: 2020-07-17
        Encoding: UTF-8
        LazyData: true
        Roxygen: list(markdown = TRUE)
        RoxygenNote: 7.1.1

    The `Type` and `Package` fields are used to construct the second and
    third elements of the workspace name (in this case,
    `Bioconductor-Workshop-BCC2020`). `Title`, `Version`, `Authors@R`,
    `Description`, `License`, and `Date` fields are used to construct
    the DASHBOARD page.

3.  Start each vignette with ‘yaml’ containing essential metadata about
    the document – title and author(s). Include other information if
    desired, e.g., abstract, (static) date of last modification.

4.  Use a file naming system AND a yaml `title` field that sorts files
    into the order in which the document content is to be presented,
    e.g., using file names `01-Setup.Rmd`, `02-...` and titles (in the
    yaml) `title: "01 Setup"`, … Naming both files and titles in this
    way provides some chance that the Rmd files are presented, or can be
    made to be presented, sensibly across the Bioconductor package
    landing page and Workspace / NOTEBOOK interface.

5.  All code chunks, regardless of annotations such as `eval = FALSE` or
    `echo = FALSE` are converted to visible, evaluated cells in jupyter
    notebooks. Replace code chunks that you do not wish the user to
    evaluate with HTML tags `<pre></pre>`.

6.  Although both Rmarkdown and python notebooks support code chunks in
    multiple languages, there is no support for this in the conversion
    process – all cells are presented as *R* code.

## Additional notes on .Rmd conversion

Current best practice is to use [quarto](https://quarto.org) for
conversion of .Rmd to ipynb. Quarto is available on the Bioconductor
docker image, or easily installed on Linux, macOS, or Windows.

Support for conversion using the Python *notedown* module is no longer
supported.

# Session info

``` r
sessionInfo()
#> R version 4.4.1 Patched (2024-08-13 r87005)
#> Platform: x86_64-pc-linux-gnu
#> Running under: Ubuntu 24.04.1 LTS
#> 
#> Matrix products: default
#> BLAS/LAPACK: /usr/lib/x86_64-linux-gnu/openblas-pthread/libopenblasp-r0.3.26.so;  LAPACK version 3.12.0
#> 
#> locale:
#>  [1] LC_CTYPE=en_US.UTF-8       LC_NUMERIC=C              
#>  [3] LC_TIME=en_US.UTF-8        LC_COLLATE=en_US.UTF-8    
#>  [5] LC_MONETARY=en_US.UTF-8    LC_MESSAGES=en_US.UTF-8   
#>  [7] LC_PAPER=en_US.UTF-8       LC_NAME=C                 
#>  [9] LC_ADDRESS=C               LC_TELEPHONE=C            
#> [11] LC_MEASUREMENT=en_US.UTF-8 LC_IDENTIFICATION=C       
#> 
#> time zone: America/New_York
#> tzcode source: system (glibc)
#> 
#> attached base packages:
#> [1] stats     graphics  grDevices utils     datasets  methods   base     
#> 
#> loaded via a namespace (and not attached):
#>  [1] compiler_4.4.1    fastmap_1.2.0     cli_3.6.3         htmltools_0.5.8.1
#>  [5] tools_4.4.1       rstudioapi_0.16.0 yaml_2.3.10       codetools_0.2-20 
#>  [9] rmarkdown_2.28    knitr_1.48        xfun_0.47         digest_0.6.37    
#> [13] rlang_1.1.4       evaluate_1.0.0
```

#' @importFrom yaml read_yaml
.vignette_paths <-
    function(path)
{
    regex <- "\\.[QqRr]md$"
    vignette_path <- file.path(path, "vignettes")
    vignettes <- dir(vignette_path, pattern = regex, full.names = TRUE)
    if (!length(vignettes)) {
        ## workshops, books, etc can have Rmd in the root directory
        vignette_path <- path
        vignettes <- dir(vignette_path, pattern = regex, full.names = TRUE)
    }
    if (!length(vignettes))
        stop(
            "unable to find vignettes",
            "\n  path: '", path, "'",
            call. = FALSE
        )

    ## use `_bookdown.yml` to order vignettes, if available
    bookdown_path <- file.path(path, "_bookdown.yml")
    if (file.exists(bookdown_path)) {
        bookdown_rmds <- read_yaml(bookdown_path)$rmd_files
        vignettes[match(bookdown_rmds, basename(vignettes))]
    } else {
        sort(vignettes)
    }
}

#' @importFrom rmarkdown render md_document
.rmd_to_md <-
    function(rmd_paths)
{
    knitr::opts_chunk$set(eval = FALSE)
    vapply(rmd_paths, render, character(1), md_document(), envir = globalenv())
}

## Extract vignette title from Rmd
#' @importFrom rmarkdown yaml_front_matter
.notebook_title_from_yaml <-
    function(rmd)
{
    ## retrieve title from yaml
    front_matter <- yaml_front_matter(rmd)
    names(front_matter) <- tolower(names(front_matter))
    front_matter$title
}

#' @importFrom utils head
.notebook_title_from_heading <-
    function(rmd)
{
    ## ...or use the first level one heading as title
    lines <- readLines(rmd)
    rmd_headings <- lines[grepl("^#[[:blank:]]+", lines)]

    ## ignore headings starting with '(PART)' (FIXME: is this just a convention?)
    PART_lines <- grepl("^#[[:blank:]]+\\(PART\\)+", rmd_headings)
    title <- head(rmd_headings[!PART_lines], 1L)

    ## remove markdown tag
    sub("^#[[:blank:]]*", "", title)
}

.notebook_title_from_path <-
    function(rmd)
{
    title <- basename(rmd)
    sub("\\.[Rr]md$", "", title)
}

.notebook_titles <-
    function(rmd_paths)
{
    titles <- vapply(rmd_paths, function(rmd) {
        title <- .notebook_title_from_yaml(rmd)
        if (length(title) == 0L)
            title <- .notebook_title_from_heading(rmd)
        if (length(title) == 0L)
            title <- .notebook_title_from_path(rmd)

        title
    }, character(1))
}

#' @importFrom utils tail
.md_to_ipynb <-
    function(md_paths)
{
    stop(
        "conversion using 'notedown' is no longer supported; ",
        "ensure `Sys.which('quarto')` finds an installation of 'quarto' ",
        "software from Posit"
    )
    ipynb_paths <- sub("\\.md", ".ipynb", md_paths)
    for (i in seq_along(md_paths)) {
        system2("notedown", c(md_paths[[i]], "-o", ipynb_paths[[i]]))
        ## FIXME: more robust way to add / update top-level metadata
        txt <- readLines(ipynb_paths[[i]])
        idx <- tail(grep(' "metadata": {},', txt, fixed = TRUE), 1)
        txt[idx] <- paste0(
            ' "metadata": {',
            '  "kernelspec": {',
            '   "display_name": "R",',
            '   "language": "R",',
            '   "name": "ir"',
            '  }',
            '},'
        )
        writeLines(txt, ipynb_paths[[i]])
    }
    ipynb_paths
}

#' @importFrom AnVILGCP avstorage avcopy
.cp_to_cloud_notebooks <-
    function(notebooks, namespace, name)
{
    bucket <- avstorage(namespace, name)
    bucket_notebooks <- paste0(bucket, "/notebooks/")
    avcopy(notebooks, bucket_notebooks)
    paste0(bucket_notebooks, basename(notebooks))
}

.rmd_to_quarto <-
    function(rmd_paths, quarto)
{
    for(rmd_path in rmd_paths) {
        if (quarto == "render") {
            system2("quarto", c("render", rmd_path, "--to", "ipynb"))
        } else {
            system2("quarto", c("convert", rmd_path))
        }
    }
    notebooks <- sub("\\.Rmd", ".ipynb", rmd_paths)
}

.quarto_exists <-
    function()
{
    nzchar(
        Sys.which("quarto")
    )
}

#' @rdname as_notebook
#'
#' @title Render vignettes as .ipynb notebooks
#'
#' @description `as_notebook()` renders Rmarkdown (`.Rmd`) or Quarto
#'     (`.Qmd`) vignettes as Juptyer (`.ipynb`) notebooks. The
#'     vignettes and notebooks are updated in an AnVIL workspace.
#'
#' @details See the vignette
#'     "Publishing R / Bioconductor Packages To AnVIL Workspaces" for
#'     details on the conversion process; best results are obtained
#'     when Quarto software is available.
#'
#' @param rmd_paths `character()` paths to Rmd or Qmd files.
#'
#' @param namespace `character(1)` AnVIL namespace (billing project)
#'     to be used.
#'
#' @param name `character(1)` AnVIL workspace name.
#'
#' @param update `logical(1)` Update (over-write any similarly named
#'     notebooks) an existing workspace? The default (FALSE) creates
#'     notebooks locally, e.g., for previewing via `jupyter notebook
#'     *ipynb`.
#'
#' @param type `character(1)` The type of notebook to be copied to the
#'     workspace. Must be on of `ipynb`, `rmd`, or `both`. `ipynb`
#'     copies only the Jupyter notebook. `rmd` copies Rmarkdown and
#'     Quarto vignettes. `both` copies both notebooks and vignettes.
#'
#' @param quarto `character(1)` If the program Quarto is installed,
#'     this parameter indicates whether the .Rmd files will be
#'     rendered or converted.  See vignette for more details.
#'
#' @return `as_notebook()` returns the paths to the local (if `update
#'     = FALSE`) or the workspace notebooks.
#'
#' @importFrom BiocBaseUtils isCharacter isScalarCharacter
#'
#' @export
as_notebook <-
    function(
        rmd_paths, namespace, name, update = FALSE,
        type = c('ipynb', 'rmd', 'both'),
        quarto = c('render', 'convert'))
{
    type = match.arg(type)
    quarto = match.arg(quarto)
    stopifnot(
        isCharacter(rmd_paths), all(file.exists(rmd_paths)),
        isScalarCharacter(namespace),
        isScalarCharacter(name),
        isScalarLogical(update)
    )

    notebooks <- character(0)
    if (type %in% c('ipynb', 'both')) {
        if (.quarto_exists()) {
            notebooks <- .rmd_to_quarto(rmd_paths, quarto)
        } else {
            mds <- .rmd_to_md(rmd_paths)
            notebooks <- .md_to_ipynb(mds)
        }
    }
    if (type %in% c('rmd', 'both')) {
        notebooks <- c(notebooks, rmd_paths)
    }

    if (update) {
        .cp_to_cloud_notebooks(notebooks, namespace, name)
    } else {
        message("use 'update = TRUE' to copy notebooks to the workspace")
        notebooks
    }
}

test_that("'.vignette_paths()' finds Qmd and Rmd notebooks", {
    package <- tempfile(); dir.create(package)
    vignettes <- file.path(package, "vignettes"); dir.create(vignettes)
    ## rmd only
    rmd_vignette <- tempfile(tmpdir = vignettes, fileext = ".Rmd")
    writeLines("", rmd_vignette)
    expect_identical(.vignette_paths(package), rmd_vignette)
    ## rmd + qmd
    qmd_vignette <- tempfile(tmpdir = vignettes, fileext = ".Qmd")
    writeLines("", qmd_vignette)
    expect_identical(
        .vignette_paths(package),
        sort(c(rmd_vignette, qmd_vignette))
    )
    ## qmd only
    unlink(rmd_vignette)
    expect_identical(.vignette_paths(package), qmd_vignette)
})

test_that("'.notebook_title_from_*()' work", {
    txt <- c(
        '---',
        'title: "Title from YAML"',
        '---',
        '# (PART) A part',
        '# Title as heading'
    )

    expect_identical(
        .notebook_title_from_yaml(textConnection(txt)),
        "Title from YAML"
    )
    expect_identical(
        .notebook_title_from_heading(textConnection(txt)),
        "Title as heading"
    )

    txt <- c(
        '---',
        'title: "Title as YAML only"',
        '---',
        '# (PART) A part'
    )
    expect_identical(
        .notebook_title_from_yaml(textConnection(txt)),
        "Title as YAML only"
    )
    expect_true(length(.notebook_title_from_heading(textConnection(txt))) == 0L)
                                
    txt <- "# Title as heading only"
    expect_true(length(.notebook_title_from_yaml(textConnection(txt))) == 0L)
    expect_identical(
        .notebook_title_from_heading(textConnection(txt)),
        "Title as heading only"
    )

    txt <- c(
        '---',
        'Title: "Title from capitalized YAML"',
        '---'
    )
    expect_identical(
        .notebook_title_from_yaml(textConnection(txt)),
        "Title from capitalized YAML"
    )

    txt <- c(
        '---',
        'description: "YAML without title"',
        '---',
        '#  (PART) Body without level one # heading',
        '## Level two' 
    )
    expect_true(length(.notebook_title_from_yaml(textConnection(txt))) == 0L)
    expect_true(length(.notebook_title_from_heading(textConnection(txt))) == 0L)

    ## from path
    expect_identical(.notebook_title_from_path("foo/bar.Rmd"), "bar")
    expect_identical(.notebook_title_from_path("foo/bar.rmd"), "bar")
    expect_identical(.notebook_title_from_path("foo/bar"), "bar")
})

#' @importFrom AnVIL Terra
.get_terra <- local({
    terra <- NULL
    renew <- NULL
    function() {
        if (is.null(terra) || Sys.time() > renew) {
            renew <<- Sys.time() + 3600L
            terra <<- Terra()
        }
        terra
    }
})

#' @importFrom httr status_code http_status content
.stop <-
    function(response, namespace, name, text)
{
    message <- content(response)$message
    if (is.null(message))
        message <- paste(as.character(content(response)), collapse = "\n")
    stop(
        text,
        "\nworkspace: ", namespace, "/", name,
        "\nstatus code: ", status_code(response),
        "\nhttp status: ", http_status(response)$message,
        "\nresponse content:\n", message,
        call. = FALSE
    )
}

.template <-
    function(tmpl)
{
    tmpl_path <- system.file(package="AnVILPublish", "template", tmpl)
    readLines(tmpl_path)
}

#' @importFrom jsonlite unbox
.create_workspace <-
    function(namespace, name)
{
    createWorkspace <- .get_terra()$createWorkspace
    response <- createWorkspace(
        namespace = namespace, name = name,
        attributes = list(
            description = unbox("New workspace")
        )
    )
    if (status_code(response) >= 400L)
        .stop(response, namespace, name, "create workspace failed")
}

.name_from_path <-
    function(path)
{
    package <- basename(path)
    directory <- dirname(path)
    descr <- tryCatch({
        packageDescription(package, directory, c("Package", "Type"))
    }, warning = function(w) {
        stop("no DESCRIPTION found at '", path, "'", call. = FALSE)
    })

    type <- ifelse(is.na(descr$Type), "Package", descr$Type)
    paste0(type, "-", descr$Package)
}

#' @importFrom utils packageDescription citation
#'
#' @importFrom stats setNames
.package_description <-
    function(path)
{
    package <- basename(path)
    directory <- dirname(path)
    descr <- packageDescription(package, directory)

    if (is.null(descr[["Author"]])) {
        parsed = tools:::.expand_package_description_db_R_fields(unlist(descr))
        descr[["Author"]] <- parsed[["Author"]]
        descr[["Maintainer"]] <- parsed[["Maintainer"]]
    }
    descr[["Authors"]] <- lapply(
        strsplit(descr[["Author"]], "\n")[[1]],
        function(x) setNames(sub(",$", "", trimws(x)), "Author")
    )
    citn <- withCallingHandlers({
        citation(package, directory)
    }, warning = function(...) {
        ## silence warnings, from no 'date' field?
        invokeRestart("muffleWarning")
    })
    if (is.null(citn$year))
        citn$year <- format(Sys.Date(), "%Y")

    descr[["Citation"]] <- format(citn, "text")

    descr
}

.package_dependencies <-
    function(path)
{
    package <- basename(path)
    directory <- dirname(path)
    descr <- packageDescription(package, directory)

    pkgs <- c(descr$Depends, descr$Imports, descr$Suggests, descr$LinkingTo)
    if (is.null(pkgs)) {
        descr[["NotebookPackages"]] <- character()
        return(descr["NotebookPackages"])
    }
    pkgs <- unlist(strsplit(pkgs, "[[:space:]]*,[[:space:]]+"))

    pattern <- "^R([[:space:]]*\\(.*\\))?$"
    pkgs <- pkgs[grep(pattern, pkgs, invert = TRUE)]
    pkgs <- sub(" .*", "", pkgs)

    txt <- paste0('"', pkgs, '"', collapse=", ")
    txt <- paste(strwrap(txt, indent = 4, exdent = 4), collapse="\n")
    descr[["NotebookPackages"]] <- paste("\n", txt, "\n")

    descr["NotebookPackages"]
}


#' @importFrom rmarkdown yaml_front_matter
.rmd_vignette_authors <-
    function(authors)
{
    if (is.character(authors)) {
        ## author: Iman Author, etc
        list(setNames(authors, "name"))
    } else {
        ## author:
        ## -  name: ...
        authors
    }
}

.rmd_vignette_description <-
    function(path, type)
{
    rmd <- .vignette_paths(path)
    yaml <- lapply(rmd, yaml_front_matter)
    titles <- .notebook_titles(rmd)
    yaml <- Map(function(x, title, rmd) {
        x$title <- unname(title)
        if (type %in% c("ipynb", "both"))
            x$ipynb <- sub("\\.[Rr]md", ".ipynb", basename(rmd))
        if (type %in% c("rmd", "both"))
            x$rmd <- basename(rmd)
        x$vignette_authors <- .rmd_vignette_authors(x$author)
        x
    }, yaml, titles, rmd)
    vignette_description <- list(Vignettes = yaml)

    vignette_description
}

#' @importFrom jsonlite unbox
.set_dashboard <-
    function(dashboard, namespace, name)
{
    setAttributes <- .get_terra()$setAttributes
    response <- setAttributes(
        namespace, name,
        list(description = unbox(dashboard))
    )
    if (status_code(response) >= 400L)
        .stop(response, namespace, name, "set dashboard failed")

    return(invisible(TRUE))
}

#' @importFrom AnVILGCP avstorage avtable_import
#'
#' @importFrom whisker whisker.render
#'
#' @importFrom readr read_csv
.set_table <-
    function(table_path, namespace, name)
{
    data <- list(
        bucket = avstorage(namespace, name)
    )

    txt <- readLines(table_path)
    fl <- tempfile()
    writeLines(whisker.render(txt, data), fl)
    tbl <- readr::read_csv(fl)
    response <- avtable_import(tbl, namespace = namespace, name = name)
    TRUE
}

.set_tables <-
    function(path, namespace, name)
{
    table_path <- file.path(path, "inst", "tables")
    table_paths <- dir(table_path, full.names = TRUE)

    if (!length(table_paths)) # early exit -- no tables for update
        return(TRUE)

    result <- vapply(
        table_paths, .set_table, logical(1),
        namespace, name
    )
    all(result)
}

#' @rdname as_workspace
#'
#' @title Render R packages as AnVIL workspaces
#'
#' @description `as_workspace()` renders a package source tree (e.g.,
#'     from a git checkout) as an AnVIL workspace.
#'
#' @details Information from the DESCRIPTION file and Rmd YAML are
#'     used to populate the 'DASHBOARD' tab.  See `?as_notebook()` for
#'     details on how vignettes are processed to notebooks.
#'
#' @inheritParams as_notebook
#'
#' @param path `character(1)` path to the location of the package
#'     source code.
#'
#' @param create `logical(1)` Create a new project?
#'
#' @param update `logical(1)` Update (over-write the existing
#'     DASHBOARD and any similarly named notebooks) an existing
#'     workspace?  If neither `create` nor `update` is TRUE, the code
#'     to create a workspace is run but no output generated; this can
#'     be useful during debugging.
#'
#' @param use_readme `logical(1)` Defaults to `FALSE`; if `TRUE` the
#'     content of README.md in package top-level folder is used with
#'     the package `DESCRIPTION` version and provenance metadata for
#'     rendering in the workspace 'DASHBOARD'.
#'
#' @return `as_workspace()` returns the URL of the updated workspace,
#'     invisibly.
#'
#' @importFrom whisker whisker.render
#' @importFrom BiocBaseUtils isScalarLogical
#'
#' @export
as_workspace <-
    function(path, namespace, name = NULL, create = FALSE, update = FALSE,
             use_readme = FALSE, type = c('ipynb', 'rmd', 'both'),
             quarto = c('render', 'convert'))
{
    type <- match.arg(type)
    quarto <- match.arg(quarto)
    stopifnot(
        isScalarCharacter(path), dir.exists(path),
        isScalarCharacter(namespace),
        isScalarCharacter(name) || is.null(name),
        isScalarLogical(create),
        isScalarLogical(update),
        isScalarLogical(use_readme),
        !use_readme || file.exists(file.path(path, "README.md"))
    )
    path <- normalizePath(path)

    if (is.null(name))
        name <- paste0("Bioconductor-", .name_from_path(path))

    ## create / update workspace
    if (create) {
        .create_workspace(namespace, name)
    } else if (!update) {
        message("use 'update = TRUE' to make changes to the workspace")
    }

    ## populate dashboard from package and vignette metadata
    description <- .package_description(path)
    vignette_description <- .rmd_vignette_description(path, type)
    processing <- list(
        ProcessDate = Sys.time(),
        RVersion = paste0(R.version$major, ".", R.version$minor),
        BioconductorVersion = BiocManager::version()
    )
    data <- c(description, vignette_description, processing)
    data$namespace <- namespace
    data$name <- name

    tmpl <- .template("dashboard.tmpl")
    dashboard <- whisker.render(tmpl, data)

    if (use_readme) {
        rmepath <- file.path(path, "README.md")
        rme <- paste(readLines(rmepath), collapse="\n")
        dashboard <- paste(dashboard, rme, collapse="\n")
    }

    !(create || update) || .set_dashboard(dashboard, namespace, name)

    !(create || update) || .set_tables(path, namespace, name)

    ## create setup notebook
    setup <- .package_dependencies(path)
    data <- c(data, setup)
    tmpl <- .template("setup-notebook.tmpl")
    setup_notebook <- whisker.render(tmpl, data)
    tmpdir <- tempfile()
    dir.create(tmpdir)
    rmd_setup_file <- paste0("00-", name, ".Rmd")
    rmd_setup_path <- file.path(tmpdir, rmd_setup_file)
    writeLines(setup_notebook, rmd_setup_path)

    ## build vignettes and add to workspace
    rmd_paths <- c(.vignette_paths(path), rmd_setup_path)
    as_notebook(
        rmd_paths, namespace, name, update = update || create, type, quarto
    )

    wkspc <-
        paste0("https://anvil.terra.bio/#workspaces/", namespace, "/", name)
    invisible(wkspc)
}

.BIOCONDUCTOR_USER <- "Bioconductor_User@firecloud.org"

.update_workspace_acl <-
    function(namespace, name)
{
    updateWorkspaceACL <- .get_terra()$updateWorkspaceACL
    properties <- list(list(
        accessLevel = "READER",
        canCompute = FALSE,
        canShare = TRUE,
        email = .BIOCONDUCTOR_USER
    ))
    response <- updateWorkspaceACL(
        namespace, name,
        body = properties
    )
    if (status_code(response) >= 400L)
        .stop(response, namespace, name, "update workspace permissions failed")
}

#' @rdname add_access
#'
#' @title Add Bioconductor_User group to workspace access
#'
#' @description `add_access()` adds the
#'     `Bioconductor_User` group to a workspace with `READER`
#'     permissions. Users gain access to the workspace (and others) by
#'     being added to the Bioconductor_User group.
#'
#' @param namespace character(1) namespace (billing account) under
#'     which the workspace belongs.
#'
#' @param name character(1) name of the workspace to add access
#'     credentials.
#'
#' @return `add_access()` returns TRUE, invisibly.
#'
#' @importFrom BiocBaseUtils isScalarCharacter
#'
#' @export
add_access <-
    function(namespace, name)
{
    stopifnot(
        isScalarCharacter(namespace),
        isScalarCharacter(name)
    )
    .update_workspace_acl(namespace, name)
    return(invisible(TRUE))
}

---
title: "Publishing R / Bioconductor Packages To AnVIL Workspaces"
author:
- name: Martin Morgan
  affiliation: Roswell Park Comprehensive Cancer Center
  email: Martin.Morgan@RoswellPark.org
package: AnVILPublish
output:
  BiocStyle::html_document
abstract: |
  This vignette introduces the AnVILPublish package for transforming R /
  Bioconductor packages to AnVIL workspaces. Data from the package
  DESCRIPTION file and vignette YAML chunks are used to create the 'DASHBOARD'
  workspace landing page. Vignettes are processed to Python notebooks and added
  to the workspace bucke for access via the 'NOTEBOOKS' tab.
vignette: |
  %\VignetteIndexEntry{Publishing R / Bioconductor packages to AnVIL Workspaces}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# AnVILPublish

This package produces AnVIL workspaces from R packages. Use this package to
create or update AnVIL workspaces from resources such as R / Bioconductor
packages. The metadata about the package (e.g., select information from the
package `DESCRIPTION` file and from vignette `YAML` headings) are used to
populate the 'DASHBOARD' page on AnVIL. Vignettes are translated to python
notebooks ready for evaluation in AnVIL.

## Package installation

If necessary, install the AnVILPublish library

```{r}
if (!"AnVILPublish" %in% rownames(installed.packages()))
    BiocManager::install("AnVILPublish")
```

# Requirements 

**Note**. The package currently works for Google Cloud Platform workspaces and
does _NOT_ support AnVIL workspaces that use the Azure platform.

## Best practices

There are only a small number of functions in the package; it is
likely best practice to invoke these using `AnVILPublish::...()`
rather than attaching the package to the search path.

## The `gcloud` SDK

It is necessary to have the [gcloud SDK][1] available to copy notebook
files to the workspace. Test availability with

```{r, eval = FALSE}
GCPtools::gcloud_exists()
```

and verify that the account and project are appropriate (consistent
with AnVIL credentials) for use with AnVIL

```{r, eval = FALSE}
GCPtools::gcloud_account()
GCPtools::gcloud_project()
```

Note that these be used to set, as well as interrogate, the account and project.

[1]: https://cloud.google.com/sdk

## `Quarto` software

Conversion of Rmarkdown (`.Rmd`) or Quarto (`.Qmd`) vignettes to
Jupyter (`.ipynb`) notebooks uses [Quarto][] software. It must be
available from within _R_, e.g.,

```{r, eval = FALSE}
system2("quarto", "--version")
```

The user must determine if they want their vignettes converted or
rendered into Jupyter notebooks. The difference is that `render`
automatically executes _R_ code blocks and embeds images, while
`convert` will not.

Use of Python _notedown_ for conversion is no longer supported.

[Quarto]: https://quarto.org

# Creating or updating workspaces

**CAUTION** updating an existing workspace will replace existing content
in a way that cannot be undone – you will lose content!

Workspace creation or update uses information from the DESCRIPTION
file, CSV files in inst/tables, and from the YAML metadata at the top
of vignettes. It is therefore worth-while to make sure this
information is accurate.

In the DESCRIPTION file, the Title, Version, Date, Authors@R
(preferred) or Author / Maintainer fields, Description, and License
fields are used.

Tables in inst/tables must be CSV files. Individual entries in the CSV
file may contain 'whisker' expressions for variable substitution, as
follows:

- `{{ bucket }}`: the bucket location of the (possibly newly created)
  workspace, as returned by `avstorage()`.
  
Tables are processed first with `whisker.render()` for variable
substitution, and then `readr::read_csv()` and `avtable_import()`.

In vignettes, the `title:`, `author:`, and `name:` fields are used. The abstract
is a good candidate for future inclusion.

## From package source

The one-stop route is to create a workspace from the local package source
(e.g., GitHub checkout) directory using `as_workspace()`.

```{r, eval = FALSE}
AnVILPublish::as_workspace(
    "path/to/package",
    "bioconductor-rpci-anvil",     # i.e., billing account
    create = TRUE                  # use update = TRUE for an existing workspace
)
```

Use `create = TRUE` to create a new workspace. Use `update = TRUE` to
update (and potentially overwrite) an existing workspace. One of
`create` and `update` must be TRUE. The command illustrated above does
not specify the `name =` argument, so creates or updates a workspace
`"Bioconductor-Package-<pkgname>`, where `<pkgname>` is the name of
the package read from the DESCRIPTION file; provide an explicit name
to create or update an arbitrary workspace. The option `use_readme = TRUE`
appends a `README.md` file to the formatted content of the `DESCRIPTION`
file.

`AnVILPublish::as_workspace()` invokes `as_notebook()` so this step
does not need to be performed 'by hand'.

See the command `add_access()`, below, to make the workspace available
to a wider audience.

## From collections of Rmd files

Some _R_ resources, e.g., [bookdown][] sites, are not in
packages. These can be processed to workspaces with minor
modifications.

[bookdown]: https://bookdown.org/

1. Add a standard DESCRIPTION file (e.g.,
   `use_this::use_description()`) to the directory containing the
   `.Rmd` files.

1. Use the `Package:` field to provide a one-word identifier (e.g.,
   `Package: Bioc2020CNV`) for your material. Add a key-value pair
   `Type: Workshop` or similar. The `Pacakge:` and `Type:` fields will
   be used to create the workspace name as, in the example here,
   `Bioconductor-Workshop-Bioc2020CNV`.

1. Add a 'yaml' chunk to the top of each `.Rmd` file, if not already
   present, including the title and (optionally) name information,
   e.g.,

   ```
   ---
   title: "01. Introduction to the workshop"
   author:
   - name: Iman Author
   - name: Imanother Author
   ---
   ```

Publish the resources with

```{r, eval = FALSE}
AnVILPublish::as_workspace(
    "path/to/directory",      # directory containing DESCRIPTION file
    "bioconductor-rpci-anvil",
    create = TRUE
)
```

# Updating notebooks or workspace permissions

These steps are performed automatically by `as_workspace()`, but may
be useful when developing a new workspace or revising existing
workspaces.

## Updating workspace notebooks from vignettes

Transforming vignettes to notebooks may require several iterations,
and is available as a separate operation. Use `update = FALSE` to
create local copies for preview.

```{r, eval = FALSE}
AnVILPublish::as_notebook(
    "paths/to/files.Rmd",
    "bioconductor-rpci-anvil",     # i.e., billing account
    "Bioconductor-Package-Foo",    # Workspace name
    update = FALSE                 # make notebooks, but do not update workspace
)
```

The vignette transformation process has several limitations. Only
`.Rmd` vignettes are supported. Currently, the vignette is transformed
first to a markdown document using the `rmarkdown` command
`render(..., md_document())`.  The markdown document is then
translated to Python notebook using `quarto`.

It is likely that some of the limitations of vignette rendering can be
reduced.

## Adding user access credentials to share the notebook

The `"Bioconductor_User"` group can be added to the entities that can
see the workspace. AnVIL users wishing to view the workspace should
be added to the `Bioconductor_User` group, rather than to the
workspace directly. To add the user group, use

```{r, eval = FALSE}
AnVILPublish::add_access(
    "bioconductor-rpci-anvil",
    "Bioconductor-Package-Foo"
)
```

# Vignette and .Rmd best practices

## Orientation

`.Rmd` files need to be converted to jupyter notebooks. These 'best
practices' lead to results that are more likely to be satisfactory, as
outlined here.

## Best practices

1. For packages, make sure the DESCRIPTION file is complete. Use the
   `Authors@R` notation for fully specifying authors. Add a `Date:`
   field indicating date of last modification. Follow other
   Bioconductor best practices, e.g., using and incrementing
   appropriate version numbers.

1. For collections of vignettes not in a package (e.g., a bookdown
   folder), add a DESCRIPTION file at the top level. An example is

    ```
    Package: BCC2020
    Type: Workshop
    Title: R / Bioconductor in the AnVIL Cloud
    Version: 1.0.0
    Authors@R: 
        c(person(
            given = "Martin",
            family = "Morgan",
            role = c("aut", "cre"),
            email = "Martin.Morgan@RoswellPark.org",
            comment = c(ORCID = "0000-0002-5874-8148")
        ),
        person("Nitesh", "Turaga", role = "ctb"),
        person("Lori", "Shepherd", role = "ctb"))
    Description:
        This book contains material for a 2 1/2 hour course offered at the
        Bioinformatics Community Conference 2020. Bioconductor provides
        more than 1900 R packages for the analysis and comprehension of
        high-throughput genomic data. Most users install and run
        Bioconductor on a personal computer or perhaps use an academic
        cluster. Cloud-based solutions are increasing appealing, removing
        the headaches of local installation while providing access to (a)
        better, scalable computing resources; and (b) large-scale
        'consortium' and other reference data sets. This session
        introduces the AnVIL cloud computing environment. We cover use of
        the cloud as a replacement to desktop-style computing; integrating
        workflows for 'upstream' processing of large data resources with
        interactive 'downstream' analysis and comprehension, using Human
        Cell Atlas single-cell datasets as an example; and querying
        cloud-based consortium data for integration with a users own data
        sets.
    License: CC-BY
    Date: 2020-07-17
    Encoding: UTF-8
    LazyData: true
    Roxygen: list(markdown = TRUE)
    RoxygenNote: 7.1.1
    ```
    
   The `Type` and `Package` fields are used to construct the second
   and third elements of the workspace name (in this case,
   `Bioconductor-Workshop-BCC2020`). `Title`, `Version`, `Authors@R`,
   `Description`, `License`, and `Date` fields are used to construct
   the DASHBOARD page.

1. Start each vignette with 'yaml' containing essential metadata about
   the document -- title and author(s). Include other information if
   desired, e.g., abstract, (static) date of last modification.

1. Use a file naming system AND a yaml `title` field that sorts files
   into the order in which the document content is to be presented,
   e.g., using file names `01-Setup.Rmd`, `02-...` and titles (in the
   yaml) `title: "01 Setup"`, ... Naming both files and titles in this
   way provides some chance that the Rmd files are presented, or can
   be made to be presented, sensibly across the Bioconductor package
   landing page and Workspace / NOTEBOOK interface.

1. All code chunks, regardless of annotations such as `eval = FALSE`
   or `echo = FALSE` are converted to visible, evaluated cells in
   jupyter notebooks. Replace code chunks that you do not wish the
   user to evaluate with HTML tags `<pre></pre>`.

1. Although both Rmarkdown and python notebooks support code chunks in
   multiple languages, there is no support for this in the conversion
   process -- all cells are presented as _R_ code.

## Additional notes on .Rmd conversion

Current best practice is to use [quarto][Quarto] for conversion of
.Rmd to ipynb. Quarto is available on the Bioconductor docker image,
or easily installed on Linux, macOS, or Windows.

Support for conversion using the Python _notedown_ module is no longer
supported.

# Session info {.unnumbered}

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as_workspace.R
\name{as_workspace}
\alias{as_workspace}
\title{Render R packages as AnVIL workspaces}
\usage{
as_workspace(
  path,
  namespace,
  name = NULL,
  create = FALSE,
  update = FALSE,
  use_readme = FALSE,
  type = c("ipynb", "rmd", "both"),
  quarto = c("render", "convert")
)
}
\arguments{
\item{path}{\code{character(1)} path to the location of the package
source code.}

\item{namespace}{\code{character(1)} AnVIL namespace (billing project)
to be used.}

\item{name}{\code{character(1)} AnVIL workspace name.}

\item{create}{\code{logical(1)} Create a new project?}

\item{update}{\code{logical(1)} Update (over-write the existing
DASHBOARD and any similarly named notebooks) an existing
workspace?  If neither \code{create} nor \code{update} is TRUE, the code
to create a workspace is run but no output generated; this can
be useful during debugging.}

\item{use_readme}{\code{logical(1)} Defaults to \code{FALSE}; if \code{TRUE} the
content of README.md in package top-level folder is used with
the package \code{DESCRIPTION} version and provenance metadata for
rendering in the workspace 'DASHBOARD'.}

\item{type}{\code{character(1)} The type of notebook to be copied to the
workspace. Must be on of \code{ipynb}, \code{rmd}, or \code{both}. \code{ipynb}
copies only the Jupyter notebook. \code{rmd} copies Rmarkdown and
Quarto vignettes. \code{both} copies both notebooks and vignettes.}

\item{quarto}{\code{character(1)} If the program Quarto is installed,
this parameter indicates whether the .Rmd files will be
rendered or converted.  See vignette for more details.}
}
\value{
\code{as_workspace()} returns the URL of the updated workspace,
invisibly.
}
\description{
\code{as_workspace()} renders a package source tree (e.g.,
from a git checkout) as an AnVIL workspace.
}
\details{
Information from the DESCRIPTION file and Rmd YAML are
used to populate the 'DASHBOARD' tab.  See \code{?as_notebook()} for
details on how vignettes are processed to notebooks.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as_notebook.R
\name{as_notebook}
\alias{as_notebook}
\title{Render vignettes as .ipynb notebooks}
\usage{
as_notebook(
  rmd_paths,
  namespace,
  name,
  update = FALSE,
  type = c("ipynb", "rmd", "both"),
  quarto = c("render", "convert")
)
}
\arguments{
\item{rmd_paths}{\code{character()} paths to Rmd or Qmd files.}

\item{namespace}{\code{character(1)} AnVIL namespace (billing project)
to be used.}

\item{name}{\code{character(1)} AnVIL workspace name.}

\item{update}{\code{logical(1)} Update (over-write any similarly named
notebooks) an existing workspace? The default (FALSE) creates
notebooks locally, e.g., for previewing via \verb{jupyter notebook *ipynb}.}

\item{type}{\code{character(1)} The type of notebook to be copied to the
workspace. Must be on of \code{ipynb}, \code{rmd}, or \code{both}. \code{ipynb}
copies only the Jupyter notebook. \code{rmd} copies Rmarkdown and
Quarto vignettes. \code{both} copies both notebooks and vignettes.}

\item{quarto}{\code{character(1)} If the program Quarto is installed,
this parameter indicates whether the .Rmd files will be
rendered or converted.  See vignette for more details.}
}
\value{
\code{as_notebook()} returns the paths to the local (if \code{update = FALSE}) or the workspace notebooks.
}
\description{
\code{as_notebook()} renders Rmarkdown (\code{.Rmd}) or Quarto
(\code{.Qmd}) vignettes as Juptyer (\code{.ipynb}) notebooks. The
vignettes and notebooks are updated in an AnVIL workspace.
}
\details{
See the vignette
"Publishing R / Bioconductor Packages To AnVIL Workspaces" for
details on the conversion process; best results are obtained
when Quarto software is available.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/add_access.R
\name{add_access}
\alias{add_access}
\title{Add Bioconductor_User group to workspace access}
\usage{
add_access(namespace, name)
}
\arguments{
\item{namespace}{character(1) namespace (billing account) under
which the workspace belongs.}

\item{name}{character(1) name of the workspace to add access
credentials.}
}
\value{
\code{add_access()} returns TRUE, invisibly.
}
\description{
\code{add_access()} adds the
\code{Bioconductor_User} group to a workspace with \code{READER}
permissions. Users gain access to the workspace (and others) by
being added to the Bioconductor_User group.
}
